﻿using System.Collections.ObjectModel;

namespace DataTreeExample.ViewModels
{
   public class HouseViewModel : ViewModelBase
   {
      private string _name;
      public ObservableCollection<RoomViewModel> Rooms { get; set; }

      public ObservableCollection<WindowViewModel> Windows { get; set; }

      public string Name
      {
         get
         {
            return _name;
         }
         set
         {
            if (_name != value)
            {
               _name = value;
               OnPropertyChanged("Name");
            }
         }
      }

      public HouseViewModel()
      {
         Rooms = new ObservableCollection<RoomViewModel>();
         Windows = new ObservableCollection<WindowViewModel>();
         CreateDummyRooms();
         Windows.Add(CreatDummyWindow("Roof Window"));
         this.Name = "House1";
      }

      private void CreateDummyRooms()
      {
         RoomViewModel livingRoom = new RoomViewModel{Name = "Living Room"};
         livingRoom.Windows.Add(CreatDummyWindow("Living Room Window"));
         Rooms.Add(livingRoom);

         RoomViewModel kitchenRoom = new RoomViewModel { Name = "Kitchen Room" };
         kitchenRoom.Windows.Add(CreatDummyWindow("Kitchen Room Window"));
         Rooms.Add(kitchenRoom);

         RoomViewModel bathRoom = new RoomViewModel { Name = "Bath Room" };
         bathRoom.Windows.Add(CreatDummyWindow("Bath Room Window"));
         Rooms.Add(bathRoom);
      }

      private WindowViewModel CreatDummyWindow(string windowName)
      {
         return new WindowViewModel {Name = windowName};
      }
   }
}
